               JOB  Fortran compiler -- List Phase Three -- phase 27       02704
               CTL  6611
     *
     * Each input-output statement is reduced to the address of
     * the list string (when present), the format string (when
     * present), and the tape unit number (when applicable).
     *
     * On entry, x1 is the top of the top I/O statement and x2
     * is one below the table of I/O strings, formats and numbers.
     *
     * On exit, 83 is the top of code in high core and x2 is one
     * below the bottom of code in high core.
     *
     x1        equ  89
     x2        equ  94
     *
     * Stuff in the resident area
     *
               ext00  Snapsh, Loadnx, CDovly
     *
               ext03    Start, top of phase 3
               ext25    Stuff in Phase 25 - Lister phase 1
     *
     110       dcw  @listr tri@
     *
     phas27    ldph listr tri,loadad,begn27,,,27
               xfr  phas27
     *
               ORG  begn25
     loadad    equ  *&1          Load address
  845begn27    MCW  x2,83
  852          SW   gm
  856          LCA  gm,0&X2  GM below I/O string table
  863          SBR  x2
  867testio    BW   notio,0&X1
  875          B    move  move prefix
  879          B    move  move tape number and list (r/w tape),
     *                  tape number and format (r/w i/o tape),
     *                  or format (read/print/punch)
  883          BCE  testio,1&X2,}  End of statement?
  891          CW   1&X2
  895          C    0&X1  get down to wm
  899          SAR  x1
  903          SBR  x1,1&X1
  910          B    move  move list (r/w i/o tape) or only gmwm
  914          B    testio
     *
     * Not I/O, copy everything else
     *
  918notio     CW   0&X1
  922copy      BCE  done,0&X1,
  930          B    move  move prefix
  934          B    move  move body
  938          B    copy
     *
     * Move from code area to list area
     *
  942move      SBR  movex&3
  946          LCA  0&X1,0&X2
  953          SAR  x1
  957          C    0&X2
  961          SAR  x2
  965movex     B    0-0
     *
  969done      equ  loadnx
     *
 1011gm        DCW  @ }@
 1018gmwm      DCW  @}@
               xfr  begn27
     clrme     clra begin3,gmwm,D
               xfr  clrme
