 167           job  object time format                                     054B4
     *
     * This is Gary Mokotoff's original limited format I/O routine 54B,
     * modified only to use the revised loader and revised 54A, and to
     * replace generated literals with explicit ones so we can make one
     * external.
     *
     * Externally referenced symbols are marked with asterisk in column 1.
     *
     * Several phases refer to addresses here, and in other I/O
     * routines.
     *
     * Stuff in the resident area
     *
               ext00  Snapsh, Loadnx, CDovly
     *
     x1        equ  89
     x2        equ  94
     x3        equ  99
     *
     * Address in format loader
     *
               xt54a
     *
     phs54b    ldph ,fmtbas,ld54b,skipb,skip54,54B
               xfr  phs54b
     *
 168           org  1697
*169 fmtbas    sbr  x1
 170           sw   gpwdmk
 171           cw   0&x1
 172           mcw  x3,savx3           save x3
 173           lca  k001,x3
 174           bwz  wrtap,0&x1,s       go to write tape on zone.
 175           mcw  kr,io4&7          set read tape D modifier
 176 rdtap     mcw  6&x1,loc
 177 io1       mcw  loc,io12&6
 178 io12      bce  ret,000,.          . is end of list, return
 179           ma   k006,loc
 180           mcw  loc,io15&3
 181 io15      mcw  000,addr           addr is loc of data addr
 182           sw   addr-2
 183           ma   k001,addr          addr is now loc of data addr &1
 184           mcw  addr,io2&3
 185 io2       mcw  000,savch          save char after data area
 186           mcw  addr,io3&6
 187 io3       lca  gpwdmk,000         move gp mk wd mk to data addr &1
 188           mcw  addr-3,io4&6       move first char addr of data
 189           mn   0&x1,io4&3         move tape no.
 190           s    count,count        clear read-error counter
 191           mz   ka,io4&5
 192 io4       rtw  1,000
 194           ber  rwt31
 195           mcw  addr,io5&6
 196 io5       mcw  savch,000          return char after data area
 197           ma   k001,loc           step to next variable in list
 198           cw   addr-2
 1981          bef  rwt78                                           v3m4
 1982          ma   k001,loc                                        v3m4
 199           b    io1
 200 ret       mcw  savx3,x3           restore x3
 201           sw   0&x1
 202           b    7&x1
 203 wrtap     mcw  kw,io4&7           set write tape D modifier
 204           b    rdtap
 205 rwt31     bce  rwt77,count,i      test read-error counter
 206           mn   io4&3,*&4
 207              ub%u0                backspace -- typo "%Uo" in orig
 208           bce  rwt41,io4&7,w
 209           a    k1,count           increase read-error counter
 210           b    io4
 211 rwt41     mn   io4&3,*&4
 212              ue%u0                skip and erase -- typo %Uo again
 213           b    io4
 214 rwt77     h    *-6,777            tape-error
 215 rwt78     h    *-6,888            end-of-file
     savx3     dcw  #03
     k001      dcw  001
     kr        dcw  @R@
     loc       dcw  #03
     k006      dcw  006
     addr      dcw  #06
*    limadr    equ  addr  used in Dimension phase 2
     savch     dcw  #1
     count     dcw  #1
     ka        dcw  @A@
     kw        dcw  @W@
     k1        dcw  1
 216           ltorg*
 217           dcw  @ @
     ld54b     cw   lgm
               bin  loadnx,            Load or skip phase 54C
 218 gpwdmk    dcw  @}@                group mark
*    lgm       equ  gpwdmk
 219           xfr  ld54b
