               JOB  Fortran compiler -- Condensed deck phase one -- 57     05704
               CTL  6611
     *
     * When requested (if there are no input errors), the comiler
     * will punch a self-loading card deck.  The deck is listed on
     * the printer if sense switch B is on.  This phase punches
     * only the clear-storage and bootstrap cards.
     *
     * Stuff in the resident area
     *
     phasid    equ  110  Phase ID, for snapshot dumps
     glober    equ  184  Global error flag -- WM means error
     arytop    equ  194  Top of arrays in object code
     topcor    equ  688  Top core address from PARAM card
     condns    equ  693  P for condensed deck
     *
               ext00  Snapsh, Loadnx, CDovly
               ext03  Start, top of phase 3
     *
     phas57    ldph condeck1,loadad,begn57,,,57
               xfr  phas57
     *
               ORG  begin3
     * Punch routine is used in Phase 58
     loadad    equ  *&1
* 838punch     SBR  punchx&3
  842          A    *-6,175  bump sequence number
  849          BSS  punchw,B    punch and print?
  854          P
  855punchx    B    0-0
  859punchw    MCW  180,280
  866          MCW
  867          WP
  868          BCV  *&5
  873          B    *&3
  877          CC   1
  879          B    punchx
* 883begn57    BCE  *&5,condns,P  punch condensed deck?
  891          B    done
  895          BW   done,glober
  903          LCA  arytop,arytop
  910          CS   180
  914          SW   101
  918          MCW  685,180
  925          BSS  *&5,B    punch and print?
  930          B    cont
  934          CC   1
  936          CS   332
  940          CS
  941          MCW  title,260
  948          W
  949          CC   J
  951          B    cont
  955done      B    loadnx
  964cont      LCA  k0000,175  sequence number
  971          BWZ  under4,topcor,2
  979          MCW  b1g4k,152
  986          B    punch      First bootstrap ge 4k
  990          MCW  topcor,b2ag4k
  997          MCW  b2bg4k,171
 1004          B    punch      Second bootstrap ge 4k
 1008          B    third
 1012under4    MCW  b1l4k,144
 1019          B    punch      First bootstrap lt 4k
 1023          MCW  topcor,b2al4k
 1030          MCW  b2bl4k,170
 1037          B    punch      Second bootstrap lt 4k
 1041third     MCW  r40,171
 1048          CS
 1049          LCA  b3,146
 1056          B    punch      Third bootstrap
 1060          B    done
 1107b1l4k     DCW  @,008015,019026,030,034041,045,053,0570571026@
 1136b2al4k    DCW  @L068112,102106,113/101099/I99@
 1177b2bl4k    dc   @,027A070028)027B0010270B0261,001/001113I0@
 1188r40       DCW  @,0010011040@
 1234b3        DCW  @,008015,022029,036040,047054,061068,072/061039@
 1277          DCW  @,008015,022026,030037,044,049,053034,035036@  v3m4
 1286b1g4k     DC   @N00001026@
 1315b2ag4k    DCW  @L068116,105106,110117B101/I9I@
 1357b2bg4k    dc   @H029NNNC029056B026/B001/0991,001/001117I0?@   v3m4
 1371title     DCW  @CONDENSED DECK@
 1375k0000     DCW  @0000@
 1376gmwm      DCW  @}@
               xfr  begn57
     clrme     clra begn57,gmwm,C
               xfr  clrme
