               JOB  Fortran compiler -- GEAUX phase one -- Phase 61        06104
               CTL  6611
     *
     * This phase prints the end of compilation message, initializes
     * the sense lights, and prepares the branch into the object
     * program coding.
     *
     x1        equ  89
     *
     * Addresses in the resident area
     *
     nstmts    equ  183  Number of statements, including generated stop
     *                 Beginning of code by now
     glober    equ  184  Global error flag -- WM means error
     gotxl     equ  185  XLINKF was referenced if no WM
     mantis    equ  692  FP mantissa digits
     dorwd     equ  695  U to rewind the tape in Phase 62, else N
*    gm61b     equ  680    Where XLINKF GMWM is wanted in V3M4
     *
               ext00  Snapsh, Loadnx, CDovly
     *
               ext03  Start, top or phase 3
     *
     phas61    ldph geaux one,loadad,begn61,,,61
               xfr  phas61
     *
               ORG  begin3
     loadad    equ  *&1
* 838begn61    LCA  w4,84  Initialize
  845          SW   84       sense
  849          SW              lights
  850          SW
  851          CC   1
  853          CS   332
  857          CS
  858          MCW  endmsg,218
  865          W
  866          MCW  nstmts,x1  entry address for generated code
  873          BW   errors,glober
  881          CC   J
  883          CS   332
  887          CS
  888          MCW  start,217
  895          W
  896afterr    SW   gmwm
  900          LCA  gmwm,mantis&1
               mcw  nop,dorwd  Assume loading from cards
               bce  xlrev,700,1
               mcw  rwd,dorwd  rewind if loading from tape
     * Reverse the WM status of GOTXL because that's how the
     * ldph macro works
     xlrev     bw   noxl,gotxl
               sw   gotxl     Skip Phase 61B 
               b    loadnx
     noxl      cw   gotxl
               b    loadnx    Load Phase 61B
     *
     * Skip phase 61B, the snapshot routine, because XLINKF was loaded
     * in its usual place.
     *
*    skip61    bce  skiptp,tpread&4,0  	Q: Loading from Autocoder tape?
               bce  skipcd,cdovly,1
               sw   gmwm
               rtw  1,gmwm          Skip a core-image block
               ber  tperr
     skipx     cw   gm61b           Clean up GMWM in XLINKF
               b    clean
     skipcd    r                    Skip a block from cards
               bce  skipx,68,B      Q: XFR card?
               b    skipcd
     skiptp    rtw  1,1             Skip a block from Autocoder tape          
               ber  tperr
               bce  skipx,8,B       Q: XFR record?
               b    skiptp
     *
 1056errors    CC   J
 1058          CS   332
 1062          CS
 1063          MCW  errmsg,228
 1070          W
 1071          B    afterr
 1078w4        DCW  #4
 1096endmsg    DCW  @END OF COMPILATION@
 1113start     DCW  @PRESS START TO GO@
 1114nop       NOP
 1115halt      H
 1143errmsg    DCW  @CORRECT ERRORS AND RECOMPILE@
     rwd       rwd
     clrtop    equ  *
     *
               org  *&x00  So we can clear the clear routine at the end
     *
     * Return here after reloading the snapshot routine
     *
*1020aftovl    LCA  nop,phasld
               LCA  halt,snapex
     *
     * Clear routine is here because this phase either loads or skips
     * the next one, so it cannot be an overlay between them.
     *
     clean     clra begn61,clrtop,,here,gmwm   CLRA ends with GMWM
               xfr  begn61
