               JOB  Fortran compiler -- phase 0 -- Loader                  00004
               CTL  6631
     *
     * Phase 0: SNAPSHOT and overlay loader phase.
     *
               ORG  81
   83          DC   #3  Save
   86          DC   #3    Areas
   89X1        DCW  @000@
     xxxxx1    equ  x1     for use in SFX regions
   91          DC   @00@
   94X2        DCW  @000@
     xxxxx2    equ  x2     for use in SFX regions
   96          DC   @00@
   99X3        DCW  @000@
     xxxxx3    equ  x3     for use in SFX regions
  104          DC   @0    @
  110phasid    DCW  @LOADER@  Phase ID, for snapshot
  111          DCW  #1  WM cleared if DO statement appears
  112          DCW  #1  WM cleared if DO statement appears
  113          DCW  #1  WM cleared if DO statement appears
  114          DCW  #1  WM cleared when an I/O list of DO is processed
  115          DCW  #1  WM cleared if I/O list and not limited format
  116subscr    DCW  #1  WM cleared if subscript code needed
  117series    DCW  #1  Need series routine if no WM
  118sincos    DCW  #1  Saw sinf or cosf if no WM
  119logf      DCW  #1  Saw logf if no WM
  120expf      DCW  #1  Saw expf if no WM
  121          DCW  #1  Saw atanf if no WM
  122sawabs    DCW  #1  Saw absf if no WM
  123sawneg    DCW  #1  Saw negation operator (unary minus) if no WM
  124xfixf     DCW  #1  Saw xfixf if no WM
  125floatf    DCW  #1  Saw floatf if no WM
  126          DCW  #1  Saw sqrtf if no WM 
  127          DCW  #1  Saw user function R if no WM
  128          DCW  #1  Saw user function U if no WM
  129          DCW  #1  Saw user function P if no WM
  130          DCW  #1  Saw user function W if no WM
  131          DCW  #1  Saw user function Y if no WM
  132          DCW  #1  Saw user function Z if no WM
  133          DCW  #1  Saw user function J if no WM
  134          DCW  #1  Saw user function K if no WM
  135          DCW  #1  Saw user function L if no WM
  136          DCW  #1  Saw user function M if no WM
  137          DCW  #1  Saw user function D if no WM
  138          DCW  #1  Saw user function H if no WM
  139          DCW  #1  Saw xlinkf if no WM
  142negar2    DCW  #3  Looks like negary -- see phase 20
  145tblbot    DCW  #3  One below numbers, formats, I/O lists
  148seqtab    DCW  #3  Bottom of sequence number table - 2
  151docnt     DCW  #3  Count of DO statements
  154botfmt    DCW  #3  Bottom of format strings or number table - 1
  157negar3    DCW  #3  Looks like negary -- see phase 20
  160arysiz    DCW  #3  Total array size & 2
  163negary    DCW  #3  16000 - arysiz
  180          DC   #17
  183nstmts    DCW  #3  Number of statements, including generated stop
  184glober    DC   #1  Global error flag -- WM means error
  185gotxl     DCW  #1  XLINKF was referenced if no WM
  188reltab    DCW  #3  Relocatable function table entry addresses
  191subent    DCW  #3  Entry to subscript routine
  194arytop    DCW  #3  Top of arrays in object code
  195          DC   #1
  199          DCW  @V4M1@
               job  Snapshot routine                                       00004
               ORG  333
     *
     * Snapshot routine
     *
               sfx  s
* 333snapsh    SBR  exit&3
  337          SBR  sxx&6
  341          MCW  kz3,adr5-2  Start five-digit address at zero
  348          MCW  xxxxx3,sx3&6
  355          MCW  xxxxx1,sx1&6
  362          SBR  xxxxx1,1
  369          SBR  xxxxx3,202
  376          CS   332
  380          CS
* 381phasld    MCW  phasid,210
  388          BSS  skip,F
     *
     * Print a header
     *
  393          CC   1
  395          MCW  xxxxx2,250  X2 might contain dot instead of address
  402sxx       SBR  216,0       return address was stored in B
  409sx3       SBR  256,0       x3 was stored in B
  416sx1       SBR  244,0       x1 was stored in B
  423          W
  424          CC   K
  426          ZA   kp2,w2a
  433clearh    CS   332
  437          CS
  438          CC   J
  440          MCW  adr5,306    five-digit address
  447          MCW
  448          SBR  loop&6
  452          MCW  k9,w2b-1
  459loop      MCW  w2b-1,000
  466          MCW  dots
  470          SBR  loop&6
  474          A    km10,w2b    add I0 = -10
  481          BWZ  loop,w2b-1,2  no zone in counter high digit?
  489          A    kp1,adr5-2  bump hundreds digit of address
  496          W
  497get       SW   0&X3        move data and wm to print area
  501          MCW  0&X1,0&X3
  508          BW   dowm,0&X1   skip clearing print area wm
  516          CW   0&X3
  520dowm      C    xxxxx1,topcor  Done?
  527          BU   cont        no
  532          W
  533          WM
  535rx1       MCW  sx1&6,xxxxx1   Restore index regs
  542          MCW  sx3&6,xxxxx3
  549          CS   332
  553          CS
  554          BSS  halt,G
  559          B    exit 
  563halt      H
  564exit      B    0-0
*    snapex    equ  exit
  568cont      SBR  xxxxx1,1&X1
  575          BCE  bump3,xxxxx3-2,2
  583          SBR  xxxxx3,201
  590          W
  591          WM
  593          A    kp1,w2a
  600          C    w2a,kp15
  607          BU   clearh
  612          S    w2a
  616          CCB  clearh,1
  621skip      MCW  xqtd,220
  628          W    rx1
  632bump3     A    kp1,xxxxx3
  639          B    get
  651dots      DCW  @9........@
  653          dcw  @9-@
  658adr5      DCW  00000      Five digit address
  661kz3       dcw  000  
  662kp2       DCW  &2
  664w2a       DCW  #2
  665k9        dcw  9  
  667km10      DCW  @I0@
  669w2b       DCW  #2
  670kp1       dcw  &1
  672kp15      dcw  &15
  680xqtd      dcw  @EXECUTED@
               sfx             End of snapshot routine
     *
     * Storage for parameter card
     *
               da   1x19
  685pword          5   The word PARAM
  688topcor         8   Top core address from PARAM card
  690imod           10  Integer modulus -- number of digits
  692mantis         12  Floating point mantissa digits
  693condns         13  P for condensed deck
  694snapsw         14  S for snapshot
  695c1410          15  T if run on 1410 in 1401 compatibility mode
  696fmtsw          16  X for no format, L for limited format
     *                blank for ordinary, A for A conversion
  699param          19  Parameter card is stored here
               JOB  Load Next Overlay                                      00004
     *
     * The default is to load a block at 201 and branch to it, assuming
     * it's an interphase clear or load block. If loaded from an
     * Autocoder tape, the addresses are changed to 1. If loaded from
     * cards the load and entry addresses are irrelevant.
     * 
               org  700
*    loadnx    r    40         Card overlay unless nop
*    cdovly    equ  loadnx     1 if loading from cards, N if from tape
*    tpread    rtw  1,201      Load overlay from tape
               ber  tperr      Error?
               sbr  18,tperr   In case of loading from Autocoder tape
     loadex    b    201        No, run the overlay
     *
     * Tape error handler assumes BER immediately follows RTW.
     * Tape instruction is copied into the error-count loop.
     *
*    tperr     sbr  tperrx&3
               sbr  mvread&3
               ma   km6,mvread&3  Back up to the tape instruction
     mvread    mcw  0-0,reread&7  Copy the tape instruction
     restrt    za   ecount        Clear error counter
     retry     bsp  1
     reread    rtw  0-0,0-0       Overlaid by the tape instruction
               ber  *&5           Q: Error?
     tperrx    b    0-0           A: No, done
               a    *-6,ecount    Bump error counter
               bce  retry,ecount-1,0  Not ten yet?
     nop       nop  3333       Too many tape errors
               h
               b    restrt     Restart the error counter
     ecount    dcw  00
     km6       dsa  16000-6
     *
     * Start here. Set up the loader and load phase 1.
     *
               ext03  Start, top of phase 3, where most phases begin
     *
               org  begin3        Clear routine clears down to x00
     begin0    cs   0             Get memory size
               sbr  size
               bwz  small,size,2  No zone means 4k or smaller
               bce  loadnx,1,     Cards from Real Autocoder?
               bce  loadnx,68,B     or Van's Autocoder with fast XFR?
               mcw  nop,loadnx    No, turn off card overlay
               bce  loadnx,1,B    Loaded from Compiler-Gen tape blocks?
               sbr  tpread&6,1    Autocoder tape blocks load at 1
               sbr  loadex&3        and enter at 1
               b    loadnx        Load phase 1
     small     cs   332
               cs
               mcw  msg,237
               w
               cc   1
     h6666     nop  6666
               h
               b    h6666
     size      dsa  0
     msg       dcw  @Message 0 - Program needs at least 8k@
     gmwm      dcw  @}@
               xfr  begin0
     *
     * Generate a clear block from BEGIN0 to GMWM 
     *
     clr0      clra begin0,gmwm
               xfr  clr0       Prohibited in a macro
