               JOB  Fortran compiler -- Format loader -- Phase 54A         054A4
               CTL  6611
     *
     * This phase selects the proper I/O routine and loads it into
     * its object core-storage location.
     *
     * Limited format routine is first (54B), normal format routine
     * is second (54C), A-conversion format routine is third (54D).
     *
     * Stuff in the resident area
     *
     fmtsw     equ  696  X for no format, L for limited format
     *                 blank for ordinary, A for A conversion
     *
               ext00  Snapsh, Loadnx, CDovly
     *
               xt52b  Stuff in Phase 52B -- function loader
               xt54b  Stuff in Phase 54B -- limited format
     *
     phas54    ldph formatpak,load54,begn54,,,54A
               xfr  phas54
     *
               ORG  beg52c
*    load54    equ  *&1
*    skipB     dcw  #1  Skip 54B -- Limited format
*    skipC     dcw  #1  Skip 54C -- Normal format
*    skipD     dcw  #1  Skip 54D -- A format
     *
     *           54B  54C  54D
     *        X   -    -    -
     * FMTSW  L   Y    -    -
     *      blank -    Y    -
     *        A   -    Y    Y
     *
  937begn54    SW   gmwm,fmtbas
               bce  loadnx,fmtsw,X  Limited format, skip 54BCD
               bce  afmt,fmtsw,A    A format, Skip 54B, load 54CD
               bce  lfmt,fmtsw,L
     * Not X, not A, not L
               cw   skipC           Skip 54B, load 54C, skip 54D
               b    loadnx
     lfmt      cw   skipB           Load phase 54B, skip 54CD
               b    loadnx
     afmt      cw   skipC,skipD     Skip phase 54B, load 54CD
               b    loadnx
     *
     * Skip a phase
     *
*    skip54    bce  skiptp,tpread&4,0  	Q: Loading from Autocoder tape?
               bce  skipcd,cdovly,1
               sw   gmwm
               rtw  1,gmwm          Skip a core-image block
               ber  tperr
               b    loadnx
     * Skip a block from cards.
     skipcd    r
               bce  loadnx,68,B     Q: XFR card?
               b    skipcd
     * Skip a block from Autocoder tape
     skiptp    rtw  1,1             Read one field                      
               ber  tperr
               bce  loadnx,8,B      Q: XFR record?
               b    skiptp
     *
     * Data
     *
 1253gmwm      DCW  @}@
*    gmwm54    equ  gmwm
     *
     * We can't put the overlay to clear phase 54A here because
     * phase 54A skips or loads phases 54BCD. The clear code is in
     * phase 55. And we can't put this comment after the XFR because
     * Van's autocoder generates an extra Autocoder boot record.
     *
               xfr  begn54
